'Example of a custom property containing a synoptic widget
'This plug-in depends on additional files in the "synoptic" directory

function XSILoadPlugin( in_reg )
	in_reg.Author = "ritaro"
	in_reg.Name = "Emi_AIUEON Synoptic Plugin"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterProperty "Emi_AIUEON_Synoptic"	

	'RegistrationInsertionPoint - do not remove this line

	XSILoadPlugin = true
end function

function XSIUnloadPlugin( in_reg )
	dim strPluginName
	strPluginName = in_reg.Name
	Application.LogMessage strPluginName & " has been unloaded.",siVerbose
	XSIUnloadPlugin = true
end function

function Emi_AIUEON_Synoptic_Define( ctxt )
	dim oCustomProperty
	set oCustomProperty = ctxt.Source

	oCustomProperty.AddParameter2 "path",siString,"",,,,,0,siPersistable

	'The "path" parameter associated with the synoptic control
	'specifies the full path of the synoptic html file.
	'To avoid hard-coding an absolute path, we determine the path relative to this script file.

	set oThisPlugin = Application.Plugins( "Emi_AIUEON Synoptic Plugin" )
	oCustomProperty.path.Value = oThisPlugin.OriginPath & ".." & XSIUtils.Slash & _
							 "synoptic" & XSIUtils.Slash & "Emi_AIUEON.htm"
	
	Emi_AIUEON_Synoptic_Define = true
end function

function Emi_AIUEON_Synoptic_DefineLayout( ctxt )
	dim oLayout,oItem
	set oLayout = ctxt.Source
	oLayout.Clear 
	
	oLayout.AddGroup "     ----- EMI     A . I . U . E . O . N   ----- "
	oLayout.AddRow
	oLayout.AddButton "Futu"
	oLayout.AddButton "A"
	oLayout.AddButton "I"
	oLayout.AddButton "U"
	oLayout.AddButton "E"
	oLayout.AddButton "O"
	oLayout.AddButton "N"
	oLayout.EndRow

	'Create the synoptic widget, which loads the synoptic view specified by the path parameter

	set oItem = oLayout.AddItem("path", "", siControlSynoptic)
	oItem.setattribute siUINoLabel,true

	oLayout.EndGroup
		
	Emi_AIUEON_Synoptic_DefineLayout = true
end function

function ApplyEmi_AIUEON_Synoptic_Execute( target )

	'Error handling of the input argument	
	if target = "" then
		Logmessage "Invalid argument to ApplyEmi_AIUEON_Synoptic", siError
		exit function		
	elseif target.Type = "XSICollection" then
		'target may be a collection of items, such as the current selection	
		dim oItem 
		for each oItem in target
			if NOT oItem.IsClassOf( siX3DObjectID ) then			
				Logmessage "Invalid argument " & oItem.FullName & " to ApplyEmi_AIUEON_Synoptic", siError			
				exit function
			end if
		next
	elseif NOT target.IsClassOf( siX3DObjectID ) then
		Logmessage "Invalid argument " & oItem.FullName & " to ApplyEmi_AIUEON_Synoptic", siError				
	end if 

	'Create the custom property
	dim properties		
	SIAddProp "Emi_AIUEON_Synoptic",target,,,properties
	
	'Show the custom property in the property panel	
	if  Application.Interactive then
		set view = desktop.activelayout.createview("property panel","Synoptic")	
		view.setattributevalue "targetcontent",properties(0).fullname
		
		'We use a Property Panel view instead of InspectObj because
		'we can resize the view to better fit the synoptic view
		view.resize 500,420
	end if
	
	ApplyEmi_AIUEON_Synoptic_Execute = true
end function

function Emi_AIUEON_Synoptic_OnInit( )
	Application.LogMessage "Emi_AIUEON_Synoptic_OnInit called",siVerbose
end function

function Emi_AIUEON_Synoptic_OnClosed( )
	Application.LogMessage "Emi_AIUEON_Synoptic_OnClosed called",siVerbose
end function

function Emi_AIUEON_Synoptic_OnClicked( )
	Application.LogMessage "Emi_AIUEON_Synoptic_Futu_OnClicked called",siVerbose
end function

function Emi_AIUEON_Synoptic_A_OnClicked( )
	Application.LogMessage "Emi_AIUEON_Synoptic_A_OnClicked called",siVerbose
end function

function Emi_AIUEON_Synoptic_I_OnClicked( )
	Application.LogMessage "Emi_AIUEON_Synoptic_I_OnClicked called",siVerbose
end function

function Emi_AIUEON_Synoptic_U_OnClicked( )
	Application.LogMessage "Emi_AIUEON_Synoptic_U_OnClicked called",siVerbose
end function

function Emi_AIUEON_Synoptic_E_OnClicked( )
	Application.LogMessage "Emi_AIUEON_Synoptic_E_OnClicked called",siVerbose
end function

function Emi_AIUEON_Synoptic_O_OnClicked( )
	Application.LogMessage "Emi_AIUEON_Synoptic_O_OnClicked called",siVerbose
end function

function Emi_AIUEON_Synoptic_N_OnClicked( )
	Application.LogMessage "Emi_AIUEON_Synoptic_N_OnClicked called",siVerbose
end function
